#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include "saeAnnexe.h"

void menu(void){
    printf("#--------------------------------------------------------------------#\n");
    printf("|                                                                    |\n");
    printf("|                        Menu de la SAE S1.02                        |\n");
    printf("|                                                                    |\n");
    printf("#--------------------------------------------------------------------#\n\n");
    printf("Codes pour accéder aux différents profils :\n\n");
    printf("C : Consultation.\n");
    printf("A : Administrateur.\n\n");
    printf("#--------------------------------------------------------------------#\n\n");
    printf("Choisissez votre session : ");
}

//Pile
Pile creerpile(int tmax)
{
    Pile p=(Pile)malloc(sizeof(pile));
    p->tlogi=0;
    p->tmax=tmax;
    p->tab=(int*) malloc(tmax);
    return p;
}

void empiler(Pile p, int x) 
{
    if (p->tmax==p->tlogi)
    {
        printf("Pile pleine");
        return;
    }
    p->tab[p->tlogi++]=x;
}

void afficherPileEntier(Pile p)
{
    for (int i=0; i<p->tlogi;i++) printf("%d\n",p->tab[i]);
}

int depiler(Pile p)
{
    if (p->tlogi==0)
    {
        printf("Pile vide");
        return -1;
    }
    return p->tab[--(p->tlogi)];
}

//File
File creerfile(int tmax)
{
    File f=(File)malloc(sizeof(file));
    Pile inipEntry=(Pile)malloc(sizeof(pile)/2);
    Pile inipExit=(Pile)malloc(tmax-sizeof(pile)/2);
    if (f==NULL || inipEntry==NULL || inipExit==NULL)
    {
        printf("Erreur maloc ini file\n");
        exit(1);
    }

    inipEntry->tlogi=0;
    inipEntry->tmax=tmax;
    inipEntry->tab=(int*) malloc(tmax);

    inipExit->tlogi=0;
    inipExit->tmax=tmax-tmax/2;
    inipExit->tab=(int*) malloc(tmax);

    f->pEntry=inipEntry;
    f->pExit=inipExit;
    return f;
}

void vider_file(File f)
{
    while (f->pExit->tmax!=f->pExit->tlogi && f->pEntry->tlogi!=0)
    {
        empiler(f->pExit,depiler(f->pEntry));
    }
}

void enfiler(File f, int x) 
{
    if (f->pEntry->tlogi==f->pEntry->tmax)
    {
        vider_file(f);
    }
    f->pEntry->tab[f->pEntry->tlogi]=x;
    f->pEntry->tlogi++;
}

int defiler(File f) 
{
    if (f->pExit->tlogi==0)
    {
        vider_file(f);
    }

    if (f->pExit->tlogi==0)
    {
        printf("File vide");
        return -1;
    }

    f->pExit->tlogi--;
    return f->pExit->tab[f->pExit->tlogi];
}

void afficherFileEntier(File f)
{
    for(int i=0;i<f->pExit->tlogi;++i) printf("%d\n",f->pExit->tab[i]);
    for(int i=f->pEntry->tlogi;i!=0;--i) printf("%d\n",f->pEntry->tab[i]);
}

void reset(void){
  char capt;
  printf("\n\nAppuyez sur entrer pour continuer :\n");
  scanf("%*c%c",&capt);
  system("clear");
}
